--  TG_HISTORY_DETAIL 操作历史记录表
DECLARE
  IS_EXISTS NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO IS_EXISTS
    FROM USER_TABLES T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL');
  --如果不存在
  IF IS_EXISTS = 0
  THEN
    BEGIN
           EXECUTE IMMEDIATE ' CREATE TABLE TG_HISTORY_DETAIL
    (
                              ID  INTEGER   NOT NULL,
                              BIZ_CLASS  VARCHAR(100),
                              BIZ_TYPE  VARCHAR(40),
                              BIZ_FIELD  VARCHAR(64),
                              BIZ_NO  VARCHAR(64),
                              HISTORY_DETAIL  CLOB,
                              CREATE_TIME  DATE DEFAULT SYSDATE ,
                              CREATE_USER  VARCHAR(50)
    )
';
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD CONSTRAINT TG_HISTORY_DETAIL_PK_5d7194832 PRIMARY KEY (ID)';

    END;
  ELSE
    BEGIN
     DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('ID');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD ID  INTEGER     NOT NULL';
      DBMS_OUTPUT.PUT_LINE('ID 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('ID 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('BIZ_CLASS');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_CLASS  VARCHAR(100)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_CLASS 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_CLASS 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('BIZ_TYPE');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_TYPE  VARCHAR(40)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_TYPE 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_TYPE 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('BIZ_FIELD');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_FIELD  VARCHAR(64)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_FIELD 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_FIELD 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('BIZ_NO');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_NO  VARCHAR(64)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_NO 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_NO 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('HISTORY_DETAIL');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD HISTORY_DETAIL  CLOB  ';
      DBMS_OUTPUT.PUT_LINE('HISTORY_DETAIL 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('HISTORY_DETAIL 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('CREATE_TIME');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD CREATE_TIME  DATE  DEFAULT SYSDATE  ';
      DBMS_OUTPUT.PUT_LINE('CREATE_TIME 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('CREATE_TIME 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_DETAIL')
         AND T.COLUMN_NAME = UPPER('CREATE_USER');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_DETAIL ADD CREATE_USER  VARCHAR(50)  ';
      DBMS_OUTPUT.PUT_LINE('CREATE_USER 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('CREATE_USER 已存在');
    END;
  END IF;
END;
    END;
  END IF;
        EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.ID IS ''主键''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.BIZ_CLASS IS ''实体类型''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.BIZ_TYPE IS ''业务类型''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.BIZ_FIELD IS ''业务关联单号的字段''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.BIZ_NO IS ''业务关联单号''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.HISTORY_DETAIL IS ''历史json''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.CREATE_TIME IS ''创建时间''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_DETAIL.CREATE_USER IS ''创建人权限平台登录用户名''';

END;
/


--  TG_HISTORY_RECORD 操作历史记录表
DECLARE
  IS_EXISTS NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO IS_EXISTS
    FROM USER_TABLES T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_RECORD');
  --如果不存在
  IF IS_EXISTS = 0
  THEN
    BEGIN
           EXECUTE IMMEDIATE ' CREATE TABLE TG_HISTORY_RECORD
    (
                              ID  INTEGER   NOT NULL,
                              BIZ_TYPE  VARCHAR(40),
                              BIZ_FIELD  VARCHAR(64),
                              BIZ_NO  VARCHAR(64),
                              HISTORY_RECORD  CLOB
    )
';
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_RECORD ADD CONSTRAINT TG_HISTORY_RECORD_PK_0ede77805 PRIMARY KEY (ID)';

    END;
  ELSE
    BEGIN
     DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_RECORD')
         AND T.COLUMN_NAME = UPPER('ID');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_RECORD ADD ID  INTEGER     NOT NULL';
      DBMS_OUTPUT.PUT_LINE('ID 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('ID 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_RECORD')
         AND T.COLUMN_NAME = UPPER('BIZ_TYPE');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_RECORD ADD BIZ_TYPE  VARCHAR(40)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_TYPE 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_TYPE 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_RECORD')
         AND T.COLUMN_NAME = UPPER('BIZ_FIELD');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_RECORD ADD BIZ_FIELD  VARCHAR(64)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_FIELD 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_FIELD 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_RECORD')
         AND T.COLUMN_NAME = UPPER('BIZ_NO');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_RECORD ADD BIZ_NO  VARCHAR(64)  ';
      DBMS_OUTPUT.PUT_LINE('BIZ_NO 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('BIZ_NO 已存在');
    END;
  END IF;
END;DECLARE
  COLUMNEXISTEDCOUNT NUMBER; --声明变量存储要查询的表中的列是否存在
BEGIN
  --从系统表中查询表中的列是否存在
  SELECT COUNT(1)
    INTO COLUMNEXISTEDCOUNT
    FROM USER_TAB_COLUMNS T
   WHERE T.TABLE_NAME = UPPER('TG_HISTORY_RECORD')
         AND T.COLUMN_NAME = UPPER('HISTORY_RECORD');
  --如果不存在，使用快速执行语句添加Age列
  IF COLUMNEXISTEDCOUNT = 0
  THEN
    BEGIN
      EXECUTE IMMEDIATE 'ALTER TABLE TG_HISTORY_RECORD ADD HISTORY_RECORD  CLOB  ';
      DBMS_OUTPUT.PUT_LINE('HISTORY_RECORD 添加成功!!!!!');
    END;
  ELSE
    BEGIN
      DBMS_OUTPUT.PUT_LINE('HISTORY_RECORD 已存在');
    END;
  END IF;
END;
    END;
  END IF;
        EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_RECORD.ID IS ''主键''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_RECORD.BIZ_TYPE IS ''业务类型''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_RECORD.BIZ_FIELD IS ''业务字段''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_RECORD.BIZ_NO IS ''业务单号''';
      EXECUTE IMMEDIATE 'COMMENT ON COLUMN TG_HISTORY_RECORD.HISTORY_RECORD IS ''历史json的count记录''';

END;
/


