-- TG_HISTORY_DETAIL 操作历史记录表
IF NOT EXISTS (SELECT 1 FROM sys.objects WHERE name = 'TG_HISTORY_DETAIL' AND type = 'U')
BEGIN
    CREATE TABLE TG_HISTORY_DETAIL
    (
        ID  BIGINT IDENTITY(1,1)  NOT NULL,
        BIZ_CLASS  VARCHAR(100),
        BIZ_TYPE  VARCHAR(40),
        BIZ_FIELD  VARCHAR(64),
        BIZ_NO  VARCHAR(64),
        HISTORY_DETAIL  TEXT,
        CREATE_TIME  DATETIME DEFAULT GETDATE() ,
        CREATE_USER  VARCHAR(50)
    );
    ALTER TABLE TG_HISTORY_DETAIL ADD CONSTRAINT [TG_HISTORY_DETAIL_PRIMARY] PRIMARY KEY NONCLUSTERED (ID ASC)

END
ELSE
BEGIN
   IF COL_LENGTH ('TG_HISTORY_DETAIL', 'ID') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD ID  BIGINT  NOT NULL  IDENTITY(1,1)  ; PRINT 'ID 添加成功!!!!!' END ELSE PRINT 'ID 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'BIZ_CLASS') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_CLASS  VARCHAR(100)   ; PRINT 'BIZ_CLASS 添加成功!!!!!' END ELSE PRINT 'BIZ_CLASS 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'BIZ_TYPE') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_TYPE  VARCHAR(40)   ; PRINT 'BIZ_TYPE 添加成功!!!!!' END ELSE PRINT 'BIZ_TYPE 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'BIZ_FIELD') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_FIELD  VARCHAR(64)   ; PRINT 'BIZ_FIELD 添加成功!!!!!' END ELSE PRINT 'BIZ_FIELD 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'BIZ_NO') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD BIZ_NO  VARCHAR(64)   ; PRINT 'BIZ_NO 添加成功!!!!!' END ELSE PRINT 'BIZ_NO 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'HISTORY_DETAIL') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD HISTORY_DETAIL  TEXT   ; PRINT 'HISTORY_DETAIL 添加成功!!!!!' END ELSE PRINT 'HISTORY_DETAIL 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'CREATE_TIME') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD CREATE_TIME  DATETIME    DEFAULT GETDATE() ; PRINT 'CREATE_TIME 添加成功!!!!!' END ELSE PRINT 'CREATE_TIME 已存在';
IF COL_LENGTH ('TG_HISTORY_DETAIL', 'CREATE_USER') IS  NULL BEGIN ALTER TABLE TG_HISTORY_DETAIL ADD CREATE_USER  VARCHAR(50)   ; PRINT 'CREATE_USER 添加成功!!!!!' END ELSE PRINT 'CREATE_USER 已存在';

END
       IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'ID' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'ID';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'主键' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'ID';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'BIZ_CLASS' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_CLASS';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'实体类型' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_CLASS';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'BIZ_TYPE' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_TYPE';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'业务类型' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_TYPE';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'BIZ_FIELD' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_FIELD';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'业务关联单号的字段' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_FIELD';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'BIZ_NO' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_NO';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'业务关联单号' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_NO';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'HISTORY_DETAIL' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'HISTORY_DETAIL';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'历史json' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'HISTORY_DETAIL';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'CREATE_TIME' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'CREATE_TIME';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'创建时间' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'CREATE_TIME';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_DETAIL' AND T2.NAME = 'CREATE_USER' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_DETAIL', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'CREATE_USER';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'创建人权限平台登录用户名' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_DETAIL', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'CREATE_USER';

GO

-- TG_HISTORY_RECORD 操作历史记录表
IF NOT EXISTS (SELECT 1 FROM sys.objects WHERE name = 'TG_HISTORY_RECORD' AND type = 'U')
BEGIN
    CREATE TABLE TG_HISTORY_RECORD
    (
        ID  BIGINT IDENTITY(1,1)  NOT NULL,
        BIZ_TYPE  VARCHAR(40),
        BIZ_FIELD  VARCHAR(64),
        BIZ_NO  VARCHAR(64),
        HISTORY_RECORD  TEXT
    );
    ALTER TABLE TG_HISTORY_RECORD ADD CONSTRAINT [TG_HISTORY_RECORD_PRIMARY] PRIMARY KEY NONCLUSTERED (ID ASC)

END
ELSE
BEGIN
   IF COL_LENGTH ('TG_HISTORY_RECORD', 'ID') IS  NULL BEGIN ALTER TABLE TG_HISTORY_RECORD ADD ID  BIGINT  NOT NULL  IDENTITY(1,1)  ; PRINT 'ID 添加成功!!!!!' END ELSE PRINT 'ID 已存在';
IF COL_LENGTH ('TG_HISTORY_RECORD', 'BIZ_TYPE') IS  NULL BEGIN ALTER TABLE TG_HISTORY_RECORD ADD BIZ_TYPE  VARCHAR(40)   ; PRINT 'BIZ_TYPE 添加成功!!!!!' END ELSE PRINT 'BIZ_TYPE 已存在';
IF COL_LENGTH ('TG_HISTORY_RECORD', 'BIZ_FIELD') IS  NULL BEGIN ALTER TABLE TG_HISTORY_RECORD ADD BIZ_FIELD  VARCHAR(64)   ; PRINT 'BIZ_FIELD 添加成功!!!!!' END ELSE PRINT 'BIZ_FIELD 已存在';
IF COL_LENGTH ('TG_HISTORY_RECORD', 'BIZ_NO') IS  NULL BEGIN ALTER TABLE TG_HISTORY_RECORD ADD BIZ_NO  VARCHAR(64)   ; PRINT 'BIZ_NO 添加成功!!!!!' END ELSE PRINT 'BIZ_NO 已存在';
IF COL_LENGTH ('TG_HISTORY_RECORD', 'HISTORY_RECORD') IS  NULL BEGIN ALTER TABLE TG_HISTORY_RECORD ADD HISTORY_RECORD  TEXT   ; PRINT 'HISTORY_RECORD 添加成功!!!!!' END ELSE PRINT 'HISTORY_RECORD 已存在';

END
       IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_RECORD' AND T2.NAME = 'ID' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_RECORD', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'ID';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'主键' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_RECORD', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'ID';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_RECORD' AND T2.NAME = 'BIZ_TYPE' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_RECORD', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_TYPE';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'业务类型' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_RECORD', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_TYPE';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_RECORD' AND T2.NAME = 'BIZ_FIELD' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_RECORD', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_FIELD';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'业务字段' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_RECORD', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_FIELD';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_RECORD' AND T2.NAME = 'BIZ_NO' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_RECORD', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'BIZ_NO';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'业务单号' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_RECORD', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'BIZ_NO';
    IF EXISTS(SELECT 1 FROM SYS.EXTENDED_PROPERTIES A WHERE EXISTS (SELECT 1 FROM SYS.OBJECTS T1 INNER JOIN SYS.COLUMNS T2 ON T1.OBJECT_ID = T2.OBJECT_ID WHERE T1.NAME = 'TG_HISTORY_RECORD' AND T2.NAME = 'HISTORY_RECORD' AND A.MAJOR_ID = T1.OBJECT_ID AND A.MINOR_ID = T2.COLUMN_ID)) BEGIN EXEC SYS.SP_DROPEXTENDEDPROPERTY @NAME = N'MS_DESCRIPTION', @LEVEL0TYPE = N'SCHEMA', @LEVEL0NAME = N'DBO', @LEVEL1TYPE = N'TABLE', @LEVEL1NAME = N'TG_HISTORY_RECORD', @LEVEL2TYPE = N'COLUMN', @LEVEL2NAME = N'HISTORY_RECORD';END
    EXEC SYS.SP_ADDEXTENDEDPROPERTY @NAME=N'MS_Description', @VALUE=N'历史json的count记录' , @LEVEL0TYPE=N'SCHEMA',@LEVEL0NAME=N'DBO', @LEVEL1TYPE=N'TABLE',@LEVEL1NAME=N'TG_HISTORY_RECORD', @LEVEL2TYPE=N'COLUMN',@LEVEL2NAME=N'HISTORY_RECORD';

GO

